#!/usr/bin/perl
##########################################################################
# Countdown+                    Version 2.0
# Copyright 1996 Matt Wright    mattw@worldwidemart.com
# Created 9/1/95                Last Modified 10/8/95
# Scripts Archive at:           http://www.worldwidemart.com/scripts/
# Updated 11/24/97 Bob Parker   software@vpdev.com
# Archive at:                   http://www.vpdev.com/scripts/
#
##########################################################################
# COPYRIGHT NOTICE
#
# Copyright 1996 Matthew M. Wright  All Rights Reserved.
#
# Countdown may be used and modified free of charge by anyone so long as
# this copyright notice and the comments above remain intact.  By using this
# code you agree to indemnify Matthew M. Wright from any liability that
# might arise from it's use.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  In other words, please ask first before you try and
# make money off of my program.
#
# Obtain permission before redistributing this software over the Internet or 
# in any other medium.	In all cases copyright and header must remain intact.
##########################################################################
#
# Define Variables
push(@INC,"/home/serve/vpdev/cgi-lbin");
require "cgi-lib.pl";
use GD;

# @from_date = (yyyy,mm,dd,hh,mm,ss);
# Which means: (year,month,day,hour,minute,second)
@from_date = (2001,1,1,0,0,0);

# Done
##########################################################################
####

&ReadParse(*DATA);

if ($DATA{'date'}) {
   @from_date = split(/,/, $DATA{'date'});
}

# check timezone to see if we need to add or subtract hours first

if (defined($DATA{'tz'})) {
	$mytz = $DATA{'tz'};
	$mymod=substr($mytz,0,1);
	local($modhours) = substr($mytz,1);
	$mod_time = $modhours * 3600;
}
else {
	$mod_time = 0;
}
		
# Define when various things occur, different dates, etc...
&define_dates;

# Calculate the Differences in the two dates
&calc_dates;

# Make Sure we don't get negative times.. That's not cool...
&no_negative;

# We don't want it to say 1 Years, now, do we?  Of course not!
$TextString = &proper_english;

# Check font size. 1=tiny, 2=small, 3=med, 4=large. Default small.
if ($DATA{'size'} && $DATA{'size'} >= 1 && $DATA{'size'} <= 4) {
	$TextSize = $DATA{'size'};
}
else {
	$TextSize = 2;
}

# Is there a border?
if ($DATA{'border'}) {
	$Border = 1;
}
else {
	$Border = 0;
}

# Is there a border size?
if ($DATA{'bordersize'}) {
	$BorderSize = $DATA{'bordersize'};
	# if BorderSize defined, but not border, turn it on
	if (!$Border) {
		$Border = 1;
	}
}
else {
	# if we have a border, but no size defined, use default of 2
	if ($Border) {
		$BorderSize = 2;
	}
	else {
		$BorderSize = 0;
	}
}

# did user define a background color
if ($DATA{'bgcolor'}) {
	$BGColor[0] = hex(substr($DATA{'bgcolor'},0,2));
	$BGColor[1] = hex(substr($DATA{'bgcolor'},2,2));
	$BGColor[2] = hex(substr($DATA{'bgcolor'},4,2));
}
else {
	#default white
	@BGColor = (255,255,255);
}

# did user define a foreground color
if ($DATA{'fgcolor'}) {
	$FGColor[0] = hex(substr($DATA{'fgcolor'},0,2));
	$FGColor[1] = hex(substr($DATA{'fgcolor'},2,2));
	$FGColor[2] = hex(substr($DATA{'fgcolor'},4,2));
}
else {
	# default black
	@FGColor = (0,0,0);
}
# and border color
if ($DATA{'bdcolor'}) {
	$BDColor[0] = hex(substr($DATA{'bdcolor'},0,2));
	$BDColor[1] = hex(substr($DATA{'bdcolor'},2,2));
	$BDColor[2] = hex(substr($DATA{'bdcolor'},4,2));
}
else {
	#default grey
	@BDColor = (153,153,153);
}

# Is background transparent?
if ($DATA{'transparent'}) {
	$Transparent = ($DATA{'transparent'});
}
else {
	# default no
	$Transparent = 0;
}

# Define Character width and height arrays
@CHeight = (0,8,12,13,16);     # null, tiny, small, med, large
@CWidth = (0,5,6,7,8);

# image width and height
$ImgWidth = ($CWidth[$TextSize] * length($TextString)) + 4 + ($BorderSize * 2);
$ImgHeight = $CHeight[$TextSize] + 4 + ($BorderSize * 2);

# define starting point for text in GIF
$Xpt = 2 + $BorderSize;
$Ypt = $Xpt;

# create new GIF using GD
$img = new GD::Image($ImgWidth,$ImgHeight);

# allocate colors for image
$BackColor = $img->colorAllocate($BGColor[0],$BGColor[1],$BGColor[2]);
$ForeColor = $img->colorAllocate($FGColor[0],$FGColor[1],$FGColor[2]);
$BorderColor = $img->colorAllocate($BDColor[0],$BDColor[1],$BDColor[2]);

# set border if defined
if ($Border) {
	$img->filledRectangle(0,0,$ImgWidth-1,$ImgHeight-1,$BorderColor);
	$img->filledRectangle($BorderSize,$BorderSize,$ImgWidth-$BorderSize-1,$ImgHeight-$BorderSize-1,$BackColor);
}

# set text using appropriate font size
if ($TextSize == 1) {
	$img->string(gdTinyFont,$Xpt,$Ypt,$TextString,$ForeColor);
}
elsif ($TextSize == 2) {
	$img->string(gdSmallFont,$Xpt,$Ypt,$TextString,$ForeColor);
}
elsif ($TextSize == 3) {
	$img->string(gdMediumBoldFont,$Xpt,$Ypt,$TextString,$ForeColor);
}
elsif ($TextSize == 4) {
	$img->string(gdLargeFont,$Xpt,$Ypt,$TextString,$ForeColor);
}

# make transparent if desired
if ($Transparent) {
	$img->transparent($BackColor);
}
else {
	$img->transparent(-1);
}

# print HTTP header for GIF
print "Content-type: image/gif\n\n";

# print the image
print $img->gif;

# end of program
exit;


#####################################
# Subroutines

sub define_dates {
	($f_year,$f_month,$f_day,$f_hour,$f_minute,$f_second) = @from_date;

	if ($mod_time != 0) {
		if ($mymod eq "-") {
			$my_time = time() - $mod_time;
		}
		else {
			$my_time = time() + $mod_time;
		}
	}
	else {
	   $my_time = time();
	}
	($second,$minute,$hour,$day,$month,$year,$wday,$yday,$isdst) = gmtime($my_time);

	if ($year > 70) {
		$year = "19$year";
	}
	else {
		$year ="20$year";
	}

   &leap_year_check;

   @months =
   ("XX","January","February","March","April","May","June","July",
              "August","September","October","November","December");

   @days =
   ("XX","1st","2nd","3rd","4th","5th","6th","7th","8th","9th","10th",
            "11th","12th","13th","14th","15th","16th","17th","18th","19th",
            "20th","21st","22nd","23rd","24th","25th","26th","27th","28th",
            "29th","30th","31st");

   @days_in_month = (31,$feb_days,31,30,31,30,31,31,30,31,30,31);

   $date_term = "$months[$f_month] $days[$f_day]";

   unless (uc($f_year) eq 'XX') {
      $date_term = "$date_term, $f_year";
   }
   unless (uc($f_hour) eq 'XX') {
      $date_term = "$date_term $f_hour";
   }
   unless (uc($f_minute) eq 'XX') {
      if ($f_minute < 10) {
         $date_term = "$date_term:0$f_minute";
      }
      else {
         $date_term = "$date_term:$f_minute";
      }
   }
   unless (uc($f_second) eq 'XX') {
      if ($f_second < 10) {
         $date_term = "$date_term:0$f_second";
      }
      else {
         $date_term = "$date_term:$f_second";
      }
   }

   $current_date = "$months[($month + 1)] $days[$day], $year $hour";
   if ($minute < 10) {
      $current_date = "$current_date:0$minute";
   }
   else {
      $current_date = "$current_date:$minute";
   }
   if ($second < 10) {
      $current_date = "$current_date:0$second";
   }
   else {
      $current_date = "$current_date:$second";
   }

}

sub leap_year_check {
   $yeardiv = ($year / 4);
   $yearint = int($yeardiv);
   $yeardiv1 = ($year / 100);
   $yearint1 = int($yeardiv1);

   if ($yeardiv eq $yearint && $yeardiv1 ne $yearint1) {
      $feb_days = "28";
   }
   else {
      $feb_days = "29";
   }
}

sub calc_dates {
   $real_year = ($f_year - $year);
   $real_month = (($f_month - 1) - $month);
   $real_day = ($f_day - $day);
   $real_hour = ($f_hour - $hour);
   $real_minute = ($f_minute - $minute);
   $real_second = ($f_second - $second);
}

sub no_negative {
   if ($real_second < 0) {
      $real_second = ($real_second + 60);
      $real_minute--;
   }

   if ($real_minute < 0) {
      $real_minute = ($real_minute + 60);
      $real_hour--;
   }

   if ($real_hour < 0) {
      $real_hour = ($real_hour + 24);
      $real_day--;
   }

   if ($real_day < 0) {
     $real_day = ($real_day + $days_in_month[$month]);
      $real_month--;
   }

   if ($real_month < 0) {
      $real_month = ($real_month + 12);
      $real_year--;
   }
}

sub proper_english {
   unless ($f_year eq 'XX' || $real_year == 0) {
      if ($real_year eq '1') {
         $MyString = "$real_year Year";
      } else {
         $MyString = "$real_year Years";
      }
   }

   unless ($f_month eq 'XX' || $real_month == 0) {
   	  $MyString .= ", " if (defined($MyString));
      if ($real_month eq '1') {
         $MyString .= "$real_month Month";
      } else {
         $MyString .= "$real_month Months";
      }
   }

   unless ($f_day eq 'XX' || $real_day == 0) {
   	  $MyString .= ", " if (defined($MyString));
      if ($real_day eq '1') {
         $MyString .= "$real_day Day";
      } else {
         $MyString .= "$real_day Days";
      }
   }

   unless ($f_hour eq 'XX' || $real_hour == 0) {
   	  $MyString .= ", " if (defined($MyString));
      if ($real_hour eq '1') {
         $MyString .= "$real_hour Hour";
      } else {
         $MyString .= "$real_hour Hours";
      }
   }

   unless ($f_minute eq 'XX' || $real_minute == 0) {
   	  $MyString .= ", " if (defined($MyString));
      if ($real_minute eq '1') {
         $MyString .= "$real_minute Minute";
      } else {
         $MyString .= "$real_minute Minutes";
      }
   }

   unless ($f_second eq 'XX' || $real_second == 0) {
   	  $MyString .= ", " if (defined($MyString));
      if ($real_second eq '1') {
         $MyString .= "$real_second Second";
      } else {
         $MyString .= "$real_second Seconds";
      }
   }
   return $MyString;

}
